format	PE GUI 4.0
entry	MyEntry

include '\Program Files\fasm\include\macro\masm.inc'
include '\Program Files\fasm\include\Win32axp.inc'
include 'DSSound2MP3.inc'
include	'\Program Files\fasm\include\directx\xequates\dsound.inc'		;get from madmatt's post in:
																		;http://board.flatassembler.net/topic.php?t=3911
include	'lame.inc'

;Uses DirectSound to acquire sound input, then uses lame to encode this input to an mp3 file
;When lame is initialized, lame return a parameter which sets the size of the data block it expects,
;  this block size is used to define the size of the DirectSound buffer.  This DS buffer is defined as
;  a circular buffer twice the size of the lame data block size.  A SetNotificationPositions notify point
;  is set half way thru the buffer, another is set at the end of the DS buffer.  Each time one of these 
;  notify points is reached, the just recorcded data--which should be the size of the lame data block--is
;  made available to the lame encoder thread.  The DS recording buffer is locked, and the data is copied 
;  to a globally available data area.  The availability is signaled from the DS thread to the lame
;  thread by means of an event.

section '.bss'		readable	writeable
WavFileName		db	'Test.wav', 0
MP3FileName		db	'Test.mp3', 0
szEnum			db	'Enumerating sound cards', 0
szRecord		db	'Recording and Encoding now', 0
szDone			db	'Done!', 0
szCreate		db	'About to create Buffer!', 0
szICCErr		db	'Error with InitCommonControlsEx', 0
szDBPErr		db	'Error with DialogBoxParam', 0
szGDIErr		db	'Error with GetDlgItem', 0
szSTErr			db	'Error with SetTimer', 0
szKTErr			db	'Error with KillTimer', 0
szCTErr			db	'Error with CreateThread', 0
szDSEError		db	'Error with DirectSoundEnumerate', 0
szDSCError		db	'Error with DirectSoundCreate', 0
szSCLError		db	'Error with SetCooperativeLevel', 0
szDSCEError		db	'Error with DirectSoundCaptureEnumerate', 0
szDSCCError		db	'Error with DirectSoundCaptureCreate8', 0
szGCError		db	'Error with GetCaps', 0
szCCBError		db	'Error with CreateCaptureBuffer', 0
szSError		db	'Error with Start', 0
szSpError		db	'Error with Stop', 0
szbHAError		db	'HeapAlloc Failed', 0
szGCPError		db	'Error with GetCurrentPosition', 0
szLError		db	'Error with Lock', 0
szULError		db	'Error with UnLock', 0
szbeDSErr		db	'Error with beDeinitStream', 0
szbeCSErr		db	'Error with beCloseStream', 0
szFileCrErr		db	'FileCreation Error', 0
szbeInitFail	db	'beInitStream failed!', 0
szEncodeBegin	db	'Beginning Encode', 0
szEncodeEnd		db	'Ending Encode', 0
szbeECerr		db	'beEncodeChunk Error!', 0
szbeWHerr		db	'beWriteVBRHeader Error!', 0
szMP3Event		db	'MP3Event', 0
szDelayClose	db	'Currently Recording', 13, 10, 'Close again after recording is stopped!', 0
szCheckOne		db	'At least one of the CheckBoxes must be checked!', 0
date_format		db	"yyyyMMdd ddd", 0
align 4
hwnd			dd	?
gWnd			dd	?
hWF				dd	?
hMF				dd	?
hCapEvent1		dd	?
hCapEvent2		dd	?
hStopEvent		dd	?
hTTCEvent		dd	?		;TimeToConvert
hbeStream		dd	?
startbut_handle	dd	?
stopbut_handle	dd	?
CrMP3_handle	dd	?
CrWav_handle	dd	?
LErrStrBuff		dd	?
MP3Heap			dd	?
MP3Mem			dd	?
SharedMem1		dd	?
SharedMem2		dd	?
Mem2MP3			dd	?
SharedMemSize	dd	?
CapDataPtr1		dd	?
CapDataSize1	dd	?
CapDataPtr2		dd	?
CapDataSize2	dd	?
LastDataRead	dd	?
CurPos			dd	?
numBW			dd	?
stat_handle		dd	?
timer_handle1	dd	?
timer_handle2	dd	?
pRecGUID		dd	?
sizeofdata		dd	?
dwSamples		dd	?
dwBufferSize	dd	?
;MP3Counter		dd	?
;DSCounter		dd	?
mp3_running		dd	?
recording		dd	?
szBuffer		rb	64
align 4
icex	INITCOMMONCONTROLSEX
align 4
dscc	DirectSoundCapture
align 4
dscb	DirectSoundCaptureBuffer8
align 4
dsc		DirectSound
align 4
dsn		DirectSoundNotify
align 4
dscaps	DSCCAPS
align 4
WaveEx	WAVEFORMATEX
align 4
dscbd	DSCBUFFERDESC
align 4
WavFile	WavRiff
align 4
beConfig	BE_CONFIG
align 4
cap_notify1	DSBPOSITIONNOTIFY
cap_notify2	DSBPOSITIONNOTIFY
stop_notify	DSBPOSITIONNOTIFY
align 4
IdHeader	ID3v2Header
align 4
ThisYear	IDyear
align 4
ThisTitle	IDtitle
align 4
ThiaArtist	IDartist
align 4
ThisSource	IDsource
align 4
ThisComment	IDcomment
align 4
ltd			SYSTEMTIME

section '.code'		code	readable	executable

MyEntry:
	invoke	GetModuleHandle, 0
	mov		[hwnd], eax
	mov		[icex.dwSize], sizeof.INITCOMMONCONTROLSEX		;prepare common control structure
	mov		[icex.dwICC], ICC_BAR_CLASSES or ICC_WIN95_CLASSES
	invoke	InitCommonControlsEx, icex						;initialize common controls for DateTimePicker
	.if	eax, ne, TRUE
		invoke	MessageBox, [hwnd], szICCErr, NULL, MB_OK
	.else
		invoke	DialogBoxParam, [hwnd], 1000, 0, DlgProc, 0
		.if	eax, e, -1
			invoke	MessageBox, [hwnd], szDBPErr, NULL, MB_OK
			call	DisplayError
		.endif
	.endif
	invoke	ExitProcess, 0

DlgProc	proc	hWnd, uMsg, wParam, lParam
	push	ebx edi esi

	mov		eax, [uMsg]
	cmp		eax, WM_COMMAND
		je	fCOMMAND
	cmp		eax, WM_INITDIALOG
		je	fINITDIALOG
	cmp		eax, WM_CLOSE
		je	fCLOSE
	xor	eax, eax
		jmp finish

fINITDIALOG:
	mov		eax, [hWnd]
	mov		[gWnd], eax
	invoke	GetDlgItem, [hWnd], IDC_SBR1
	.if	eax, e, NULL
		invoke	MessageBox, [gWnd], szGDIErr, NULL, MB_OK
		call	DisplayError
		jmp		fCLOSE
	.endif
	mov		[stat_handle], eax                ;get & save handles for controls
	invoke	GetDlgItem, [gWnd], START_BUT
	.if	eax, e, NULL
		invoke	MessageBox, [gWnd], szGDIErr, NULL, MB_OK
		call	DisplayError
		jmp		fCLOSE
	.endif
	mov		[startbut_handle], eax				;Start Button
	invoke	GetDlgItem, [gWnd], STOP_BUT
	.if	eax, e, NULL
		invoke	MessageBox, [gWnd], szGDIErr, NULL, MB_OK
		call	DisplayError
		jmp		fCLOSE
	.endif
	mov		[stopbut_handle], eax				;Stop Button
	invoke	EnableWindow, [stopbut_handle], FALSE
	invoke  ShowWindow, [stopbut_handle], SW_HIDE
	invoke	GetDlgItem, [gWnd], CrMP3
	.if	eax, e, NULL
		invoke	MessageBox, [gWnd], szGDIErr, NULL, MB_OK
		call	DisplayError
		jmp		fCLOSE
	.endif
	mov		[CrMP3_handle], eax					;Create MP3 File checkbox
	invoke  SendMessage, [CrMP3_handle], BM_SETCHECK, 1, 0
	invoke	GetDlgItem, [gWnd], CrWav
	.if	eax, e, NULL
		invoke	MessageBox, [gWnd], szGDIErr, NULL, MB_OK
		call	DisplayError
		jmp		fCLOSE
	.endif
	mov		[CrWav_handle], eax					;Create Wav File checkbox
;Set up event to signal MP3 thread
	invoke	CreateEvent, NULL, TRUE, FALSE, szMP3Event
	mov		[hTTCEvent], eax								;TimeToConvert Event
;	mov		[MP3Counter], 0
;Initialize lame thread to obtain size of memory objects needed for transfer between DS and MP3 threads
	invoke	RtlZeroMemory, beConfig, sizeof.BE_CONFIG
	mov		[beConfig.dwConfig], BE_CONFIG_LAME;
;	// this are the default settings for testcase.wav
	mov		[beConfig.format.LHV1.dwStructVersion], 1;
	mov		[beConfig.format.LHV1.dwStructSize], sizeof.BE_CONFIG;		
	mov		[beConfig.format.LHV1.dwSampleRate], 44100;				// INPUT FREQUENCY
	mov		[beConfig.format.LHV1.dwReSampleRate], 0;				// DON"T RESAMPLE
	mov		[beConfig.format.LHV1.nMode], BE_MP3_MODE_STEREO;		// OUTPUT IN STEREO
	mov		[beConfig.format.LHV1.dwBitrate], 128;					// MINIMUM BIT RATE
	mov		[beConfig.format.LHV1.dwMaxBitrate], 192;					// MINIMUM BIT RATE
	mov		[beConfig.format.LHV1.nPreset], LQP_R3MIX;				// QUALITY PRESET SETTING
	mov		[beConfig.format.LHV1.dwMpegVersion], MPEG1;			// MPEG VERSION (I or II)
	mov		[beConfig.format.LHV1.dwPsyModel], 0;					// USE DEFAULT PSYCHOACOUSTIC MODEL 
	mov		[beConfig.format.LHV1.dwEmphasis], 0;					// NO EMPHASIS TURNED ON
	mov		[beConfig.format.LHV1.bPrivate], 0;
	mov		[beConfig.format.LHV1.bCRC], 0;							// 
	mov		[beConfig.format.LHV1.bCopyright], 0;					// 
	mov		[beConfig.format.LHV1.bOriginal], TRUE;					// SET ORIGINAL FLAG
	mov		[beConfig.format.LHV1.bWriteVBRHeader], TRUE;			// Write INFO tag
	mov		[beConfig.format.LHV1.bEnableVBR], TRUE
	mov		[beConfig.format.LHV1.nVBRQuality], 9
;	mov		[beConfig.format.LHV1.dwVbrAbr_bps], 320000
	mov		[beConfig.format.LHV1.nVbrMethod], VBR_METHOD_NEW
	mov		[beConfig.format.LHV1.bNoRes], TRUE;					// No Bit resorvoir
	mov		[beConfig.format.LHV1.bStrictIso], TRUE;				// 
;	mov		[beConfig.format.LHV1.nQuality], TRUE;					// 

	cinvoke	beInitStream, beConfig, dwSamples, dwBufferSize, hbeStream	
		;beConfig		BE_CONFIG instance
		;dwSamples		receives number of samples to send to each beEncodeChunk
		;dwBufferSize	receives minimum size in bytes of output buffer
		;hbeStream		receives Stream handle
	.if	eax, ne, BE_ERR_SUCCESSFUL
		invoke	MessageBox, NULL, szbeInitFail, NULL, MB_OK
		jmp	cleanup
	.endif
;Create shared memory file mapping object
;	there will be a shared memory space for CapDataPtr1, (dwSamples * 2 bytes) * 2 -- more than enough
;	there will be a shared memory space for CapDataPtr2, (dwSamples * 2 bytes) * 2
;  These will be used to transfer DS captured data to the MP3 proc
;  Once in the MP3 proc, a memory space, dwSamples * 4 bytes
;	where the data transferred from CapDataPtr1 & CapDataPtr2 will be
;	reconstructed so that (dwSamples * 2 bytes) will be available for the MP3 conversion
;	and any left over will be held over for the next data sent from DS
;Therefore we need (dwSamples * 12) bytes, we'll reserve dwSamples * 16
	mov		eax, [dwSamples]			;number of dword--16 bit--samples sent to MP3 routine in each "chunk"
	shl		eax, 4						;reserve 16 times dwSamples bytes for shared memory, jtbs
	mov		[SharedMemSize], eax		;save for allocs
	add		eax, [dwBufferSize]			;add size of expected output buffer for MP3 encode
	invoke	HeapCreate, NULL, eax, eax
	mov		[MP3Heap], eax
	invoke	HeapAlloc, [MP3Heap], NULL, [dwBufferSize]
		.if	eax, e, NULL
			invoke	MessageBox, NULL, szbHAError, NULL, MB_OK
			jmp	cleanup
		.endif
	mov		[MP3Mem], eax
		;creates buffer to hold encoded data, at least dwBufferSize bytes in length
	shr		[SharedMemSize], 2			;each buffer SharedMem1, SharedMem2, & Mem2MP3 is 4 * dwSamples
	invoke	HeapAlloc, [MP3Heap], NULL, [SharedMemSize]
		.if	eax, e, NULL
			invoke	MessageBox, NULL, szbHAError, NULL, MB_OK
			jmp	.cleanup
		.endif
	mov		[SharedMem1], eax
	invoke	HeapAlloc, [MP3Heap], NULL, [SharedMemSize]
		.if	eax, e, NULL
			invoke	MessageBox, NULL, szbHAError, NULL, MB_OK
			jmp	cleanup
		.endif
	mov		[SharedMem2], eax
	invoke	HeapAlloc, [MP3Heap], NULL, [SharedMemSize]
		.if	eax, e, NULL
			invoke	MessageBox, NULL, szbHAError, NULL, MB_OK
			jmp	cleanup
		.endif
	mov		[Mem2MP3], eax
		;creates buffer to hold data to be sent to MP3 encode
;Create Thread to do MP3 conversion
	invoke	CreateThread, NULL, NULL, MP3_proc,	NULL, NULL, NULL				;begin MP3 thread to wait for DS event signal
	invoke	CloseHandle, eax
	mov		[recording], 0
	jmp		processed

fCOMMAND:
	mov		eax, [wParam]
	mov		edx, eax
	shr		edx, 16 			;High order word of wParam--the notification code--now in dx
	call	cmd_proc
	jmp		processed

fCLOSE: 
	.if	[recording]
		cominvk	dscb, Stop						;Stop recording
		invoke	MessageBox, [gWnd], szDelayClose, NULL, MB_OK
		jmp		processed
	.endif
	invoke	EndDialog, [hWnd], 0
	jmp		processed

cleanup:

processed:
	mov		eax, 1

finish:
	pop esi edi ebx
	ret
		
DlgProc	endp

cmd_proc	proc
	;We're only checking here for BN_CLICKED
	;High order word of wParam--the notification code--in dx
	cmp	dx, BN_CLICKED
	jne	.dir_out
		cmp	ax, START_BUT
		jne	.chk_stop
			invoke	SendMessage, [CrMP3_handle], BM_GETCHECK, 0, 0
			.if	eax, ne, BST_CHECKED
				invoke	SendMessage, [CrWav_handle], BM_GETCHECK, 0, 0
				.if	eax, ne, BST_CHECKED
					invoke	MessageBox, [gWnd], szCheckOne, NULL, MB_OK
					jmp		.dir_out
				.endif
			.endif
			mov		[recording], 1
			invoke  EnableWindow, [startbut_handle], FALSE	;disable start button
			invoke  EnableWindow, [stopbut_handle], TRUE	;enable stop button
			invoke  ShowWindow, [startbut_handle], SW_HIDE
			invoke  ShowWindow, [stopbut_handle], SW_RESTORE
;			mov		[DSCounter], 0
			invoke	CreateThread, NULL, NULL, Dsound_proc, NULL, NULL, NULL				;start DS recording
			invoke	CloseHandle, eax
				jmp	.dir_out
.chk_stop:
		cmp	ax, STOP_BUT
		jne	.dir_out
			cominvk	dscb, Stop						;Stop recording
			invoke  EnableWindow, [startbut_handle], TRUE	;enable start button
			invoke  EnableWindow, [stopbut_handle], FALSE	;disable stop button
			invoke  ShowWindow, [startbut_handle], SW_RESTORE
			invoke  ShowWindow, [stopbut_handle], SW_HIDE
			jmp	.dir_out
.cleanup:
.dir_out:
	mov	eax, TRUE
	ret

cmd_proc	endp

Dsound_proc	proc
local	bytes2Write:DWORD
local	bytesWritten:DWORD
;Enumerate all sound cards available on the system
;Looks for my 'iMic' USB "SoundCard" and retrieve the GUID for that card to use with DirectSoundCreate8

	mov		[pRecGUID], NULL				;Use default device if Enumerate fails
	invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szEnum

;Set Input and Output SoundCards by enumerating all sound cards
	invoke	DirectSoundEnumerate, DSEcallback, NULL

;Create the DirectSound object
	invoke	DirectSoundCreate8, [pRecGUID], dsc, NULL

;set cooperative level of the object
	cominvk	dsc, SetCooperativeLevel, [hwnd], DSSCL_NORMAL

;Create Sound Capture object
	invoke	DirectSoundCaptureEnumerate, DSEcallback, NULL
	invoke	DirectSoundCaptureCreate8, [pRecGUID], dscc, NULL

;Check cap
	mov		[dscaps.dwSize], sizeof.DSCCAPS
	cominvk	dscc, GetCaps, dscaps
	cmp		[dscaps.dwChannels], 2
;my card returns
;2 Channels
	cmp		[dscaps.dwFormats], 3
;my card returns
;0xCCC
;#define WAVE_FORMAT_1M16       0x00000004       /* 11.025 kHz, Mono,   16-bit */
;#define WAVE_FORMAT_1S16       0x00000008       /* 11.025 kHz, Stereo, 16-bit */
;#define WAVE_FORMAT_2M16       0x00000040       /* 22.05  kHz, Mono,   16-bit */
;#define WAVE_FORMAT_2S16       0x00000080       /* 22.05  kHz, Stereo, 16-bit */
;#define WAVE_FORMAT_4M16       0x00000400       /* 44.1   kHz, Mono,   16-bit */
;#define WAVE_FORMAT_4S16       0x00000800       /* 44.1   kHz, Stereo, 16-bit */
	cmp		[dscaps.dwFlags], 4
;my card returns
;0x41
;DSCCAPS_MULTIPLECAPTURE	= $1
;DSCAPS_CERTIFIED			= $40

;Create Capture Buffer for recording
	invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szCreate
	;set DirectSound recording parameters
	mov		[WaveEx.wFormatTag], WAVE_FORMAT_PCM
	mov		[WaveEx.nChannels], 2
	mov		[WaveEx.nSamplesPerSec], 44100
	mov		[WaveEx.nAvgBytesPerSec], 176400	;= WaveEx.nSamplesPerSec * WaveEx.nBlockAlign
	mov		[WaveEx.nBlockAlign], 4				;= nChannels * wBitsPerSample / 8
	mov		[WaveEx.wBitsPerSample], 16
	mov		[WaveEx.cbSize], 0

	mov		[dscbd.dwSize], sizeof.DSCBUFFERDESC
	mov		[dscbd.lpwfxFormat], WaveEx

	mov		eax, [dwSamples]					;number of 16-bit samples lame wants for conversion
	shl		eax, 2								;times 2 -> bytes,  times 2 -> 2 notifications per buffer
	mov		[dscbd.dwBufferBytes], eax
;	mov		[dscbd.dwBufferBytes], 176400		;= WaveEx.nAvgBytesPerSec * 1 second buffer
	mov		[dscbd.dwFlags], 0
	mov		[dscbd.dwFXCount], 0

	cominvk	dscc, CreateCaptureBuffer, dscbd, dscb, NULL
	
;Set up first notification event
	mov		eax, [dscbd.dwBufferBytes]			;using 1 second buffer
	shr		eax, 1
	dec		eax									;zero based counting
	mov		[cap_notify1.dwOffset], eax				;Sets notification point (1) at 1 less than half of the 1 second buffer
	invoke	CreateEvent, NULL, TRUE, FALSE, NULL	;The 'TRUE' requires the event to be reset to clear
	mov		[hCapEvent1], eax
	mov		[cap_notify1.hEventNotify], eax

;Set up second notification event
	mov		eax, [dscbd.dwBufferBytes]
	dec		eax										;zero based counting
	mov		[cap_notify2.dwOffset], eax				;Sets notification point (2) at 1 less than the end of the 1 second buffer
	invoke	CreateEvent, NULL, TRUE, FALSE, NULL
	mov		[hCapEvent2], eax
	mov		[cap_notify2.hEventNotify], eax

;Set up stop notification event
	mov		[stop_notify.dwOffset], DSBPN_OFFSETSTOP
	invoke	CreateEvent, NULL, TRUE, FALSE, NULL
	mov		[hStopEvent], eax
	mov		[stop_notify.hEventNotify], eax

;Get Notification interface for Capture Buffer
	cominvk	dscb, QueryInterface, IID_IDirectSoundNotify, dsn
	
	cominvk	dsn, SetNotificationPositions, 3, cap_notify1
	
;Create .wav file
	invoke	CreateFile, WavFileName, GENERIC_WRITE or GENERIC_READ, NULL, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	mov		[hWF], eax

;Write generic wavfile header, we need to change the "size" fields in the header once we know the final file size
	invoke	WriteFile, [hWF], WavFile, sizeof.WavRiff, numBW, NULL

	mov		[sizeofdata], 0				;initialize variable to keep track of total bytes written after header
	mov		[LastDataRead], 0			;initialize point in buffer where last read stopped

;Record sound
	invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szRecord
	cominvk	dscb, Start, DSCBSTART_LOOPING				;Start recording to DirectSoundCaptureBuffer8 - dscb and "loop"

;Set timer to issue "Stop" command after preSet milliseconds
;	invoke	SetTimer, [gWnd], 1011, msRecordTime, NULL
;	mov		[timer_handle2], eax

	mov		[szBuffer], 0					;zero status string

;Loop while waiting for notifications
wait_again:
	invoke	WaitForMultipleObjects, 3, hCapEvent1, FALSE, msRecordTime + 1000
	sub		eax, WAIT_OBJECT_0
;	add		[DSCounter], 1
	.if	eax, e, 0							;hCapEvent1	signaled
		LockAndGet							;macro to lock the Capture Buffer and get the newest data
;		.if	[DSCounter], a, 100
;			invoke	StrCatBuff, szBuffer, '1', 64
;			invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szBuffer	;shows indication in status bar that something is happening
;			mov		[DSCounter], 0
;		.endif
		invoke	ResetEvent, [hCapEvent1]
	.elseif eax, e, 1						;hCapEvent2	signaled
		LockAndGet
;		.if	[DSCounter], a, 100
;			invoke	StrCatBuff, szBuffer, '2', 64
;			invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szBuffer	;shows indication in status bar that something is happening
;			mov		[DSCounter], 0
;		.endif
		invoke	ResetEvent, [hCapEvent2]
	.elseif	eax, e, 2						;hStopEvent	signaled
		LockAndGet
;		invoke	StrCatBuff, szBuffer, '3', 64
;		invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szBuffer	;shows indication in status bar that we've finished
		invoke	ResetEvent, [hStopEvent]
		mov		[recording], 0
		jmp	rec_done
	.else
		add	eax, WAIT_OBJECT_0
		.if	eax, e, WAIT_TIMEOUT					;since we are recording only for msRecordTime msecs, 
													; this triggers if it waits 1000 msecs. beyond that
			invoke	StrCatBuff, szBuffer, 'TimeOut!', 64
			invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szBuffer
			jmp	rec_done
		.endif
	.endif
	jmp		wait_again

rec_done:
	mov		eax, [sizeofdata]								;size of PCM data
	mov		[WavFile.sc2Size], eax							;data chunk size
	add		eax, 36											;adds size of wav header - 8
	mov		[WavFile.ChunkSize], eax

	invoke	SetFilePointer, [hWF], 0, NULL, FILE_CURRENT	;get current file pointer
	push	eax													;save for later
	invoke	SetFilePointer, [hWF], 0, NULL, FILE_BEGIN				;go back to beginning of file
	invoke	WriteFile, [hWF], WavFile, sizeof.WavRiff, numBW, NULL	;ReWrite wav header info
	pop		eax														;recall previous end of data pointer 
	invoke	SetFilePointer, [hWF], eax, NULL, FILE_BEGIN		;go to end of data
	invoke	SetEndOfFile, [hWF]									;set end of file

	invoke	CloseHandle, [hWF]

;Close out and finalize the MP3 file
	cinvoke	beDeinitStream, [hbeStream], [MP3Mem], addr bytes2Write
		.if eax, ne, BE_ERR_SUCCESSFUL
			invoke	MessageBox, NULL, szbeDSErr, NULL, MB_OK
		.endif

	invoke	WriteFile, [hMF], [MP3Mem], [bytes2Write], addr bytesWritten, NULL
		.if	eax, e, 0
			call	DisplayError
		.endif

	cinvoke	beCloseStream, [hbeStream]
		.if eax, ne, BE_ERR_SUCCESSFUL
			invoke	MessageBox, NULL, szbeCSErr, NULL, MB_OK
		.endif

	invoke	HeapFree, [MP3Heap], NULL, [MP3Mem]

.cleanup:
	invoke	CloseHandle, [hMF]
	
	cinvoke	beWriteVBRHeader, MP3FileName
		.if eax, ne, BE_ERR_SUCCESSFUL
			invoke	MessageBox, NULL, szbeWHerr, NULL, MB_OK
		.endif

	invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szEncodeEnd

	ret

Dsound_proc	endp

DSEcallback	proc	lpGuid, lpcstrDescription, lpcstrModule, lpContext

;When DirectSoundEnumerate is called, Each audio device supported causes this callback routine to trigger
; the default device triggers this routine twice, once with a NULL GUID and once with its "real" GUID.
	mov		eax, [lpcstrDescription]
	mov		eax, [eax]
	.if eax, e, 'iMic'		;my USB audio device is found and we will use it
		push	[lpGuid]
		pop		[pRecGUID]
	.endif
	ret

DSEcallback	endp

MP3_proc	proc
local	headPtr:DWORD
local	tailPtr:DWORD
local	copyFrom:DWORD
local	numBytes:DWORD
local	lameSize:DWORD
local	bytes2Write:DWORD
local	bytesWritten:DWORD

;On entry, zero out Mem2MP3 buffer and headPtr, tailPtr, & numBytes
	call	SetUpMP3File								;Create MP3 file and setup IDv3 tags
	mov		eax, [dwSamples]
	shl		eax, 1
	mov		[lameSize], eax								;this is the size in bytes of chunk of data to send to lame
	invoke	RtlZeroMemory, [Mem2MP3], [SharedMemSize]	;Clear buffer used to provide data for lame
	mov		eax, [Mem2MP3]
	mov		[headPtr], eax								;highest memory point of data
	mov		[tailPtr], eax								;lowest memory point of data, this should be the [Mem2MP3]
	add		eax, [lameSize]
	mov		[copyFrom], eax								;this is the point from which data will be moved after lame call
														;to the beginning of the buffer
	mov		[numBytes], 0								;number of bytes held for next chunk to send to lame
;As 
.wait_again:
	invoke	WaitForSingleObject, [hTTCEvent], msRecordTime + 1000
;We are here when the LockAndGet macro "Sets" this Event
; From LockAndGet, we possibly locked and copy two Chunks of data
; 1 chunk starting where the last chunk left off and
; 2 chunk, because 1 chunk wrapped around the capture buffer and
; continued writing at the beginning of the buffer
; if we sized the capture buffer properly, this wrap around won't happen! (But It does!!)
;1 chunk is transferred in buffer SharedMem1 size CapDataSize1
;2 chunk is transferred in buffer SharedMem2 size CapDataSize2

	sub		eax, WAIT_OBJECT_0
	.if	eax, e, 0							;hTTCEvent	signaled
;Copy the contents of SharedMem1 to the point where [headPtr] is pointing and add [CapDataSize1] to numBytes
		invoke	RtlMoveMemory, [headPtr], [SharedMem1], [CapDataSize1]
		invoke	StrCatBuff, szBuffer, '-', 64
		invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szBuffer	;shows indication in status bar that something is happening
		mov		eax, [CapDataSize1]
		add		[numBytes], eax
		add		[headPtr], eax				;move headPtr to top of new data
;If [CapDataSize2] != 0, Copy the contents of SharedMem2 to the point where [headPtr] is pointing and add [CapDataSize2] to numBytes
		.if [CapDataSize2], ne, 0
			invoke	RtlMoveMemory, [headPtr], [SharedMem2], [CapDataSize2]
			mov		eax, [CapDataSize2]
			add		[numBytes], eax
			add		[headPtr], eax				;move headPtr to top of new data
		.endif
		mov	eax, [lameSize]
		.if [numBytes], ae, eax				;We have enough data to send to lame
			cinvoke	beEncodeChunk, [hbeStream], [dwSamples], [tailPtr], [MP3Mem], addr bytes2Write
				.if eax, ne, BE_ERR_SUCCESSFUL
					invoke	MessageBox, NULL, szbeECerr, NULL, MB_OK
				.endif
			invoke	WriteFile, [hMF], [MP3Mem], [bytes2Write], addr bytesWritten, NULL
				.if	eax, e, 0
					call	DisplayError
				.endif
			mov		eax, [headPtr]
			sub		eax, [lameSize]			;correct for the amount processed by lame
			.if	eax, a, [tailPtr]			;if we did not process all the data in the holding buffer
				mov		eax, [headPtr]		;move remaining data to beginning of holding buffer
				sub		eax, [copyFrom]
				invoke	RtlMoveMemory, [tailPtr], [copyFrom], eax
			.endif
			mov		eax, [lameSize]
			sub		[numBytes], eax
			sub		[headPtr], eax
		.endif

;		.if [CapDataSize2], ne, 0
;			mov		eax, [dwSamples]
;			shl		eax, 1
;			sub		eax, [CapDataSize1]
;			sub		eax, [CapDataSize2]
;			.if	eax, l, 0
;				invoke	StrCatBuff, szBuffer, '-', 64
;				invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szBuffer	;shows indication in status bar that something is happening
;			.elseif	eax, g, 0
;				invoke	StrCatBuff, szBuffer, '+', 64
;				invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szBuffer	;shows indication in status bar that something is happening
;			.elseif	eax, e, 0
;				invoke	StrCatBuff, szBuffer, '0', 64
;				invoke	SendMessage, [stat_handle], SB_SETTEXT, 0, szBuffer	;shows indication in status bar that something is happening
;			.endif
;		.endif
	.endif
	invoke	ResetEvent, [hTTCEvent]
	mov		[mp3_running], 0				;shows that the routine is finished
	jmp		.wait_again
	ret

MP3_proc	endp

SetUpMP3File	proc
local	bytesWritten:DWORD

	invoke	CreateFile, MP3FileName, GENERIC_WRITE or GENERIC_READ, NULL, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
		.if	eax, e, INVALID_HANDLE_VALUE
			call	DisplayError
			ret
		.endif
	mov		[hMF], eax
;Write ID3v2 Header
	mov		eax, sizeof.IDyear
	add		eax, sizeof.IDtitle
	add		eax, sizeof.IDartist
	add		eax, sizeof.IDsource
	add		eax, sizeof.IDcomment
;ID3v2Header.size is funky! 4 bytes, the bit 7 of each byte must be 0
;	so bit 7 of the low order byte--byte 0--is shifted into bit0 of byte 1
	shl		eax, 1					;this shifts the whole thing 1
	shr		al, 1					;this corrects byte 0
	shl		eax, 1
	shr		al, 1
	shr		ah, 1					;this should make byte 0 and byte 1 correct
									;still need to fix byte 2 and byte 3
	mov		ecx, eax
	shr		ecx, 15
	shr		cl, 1
	shl		ecx, 16
	and		eax, 0ffffh
	or		eax, ecx
	bswap	eax
	mov		[IdHeader.size], eax
	invoke	WriteFile, [hMF], IdHeader, sizeof.ID3v2Header, addr bytesWritten, NULL

;Get date string for YEAR tag
;	call	get_dt
	invoke	GetLocalTime, ltd
	invoke	GetDateFormat, LOCALE_SYSTEM_DEFAULT, NULL, ltd, date_format, szBuffer, 32
;	invoke	MessageBox, 0,	szBuffer, NULL, MB_OK
	invoke	RtlMoveMemory, ThisYear.data,    szBuffer, 4
	invoke	RtlMoveMemory, ThisYear.data+5,  szBuffer+4, 2
	invoke	RtlMoveMemory, ThisYear.data+8,  szBuffer+6, 2
	invoke	RtlMoveMemory, ThisYear.data+11, szBuffer+9, 3

	mov		eax, [ThisYear.size]
	bswap	eax
	mov		[ThisYear.size], eax
	invoke	WriteFile, [hMF], ThisYear, sizeof.IDyear, addr bytesWritten, NULL

	mov		eax, [ThisTitle.size]
	bswap	eax
	mov		[ThisTitle.size], eax
	invoke	WriteFile, [hMF], ThisTitle, sizeof.IDtitle, addr bytesWritten, NULL

	mov		eax, [ThiaArtist.size]
	bswap	eax
	mov		[ThiaArtist.size], eax
	invoke	WriteFile, [hMF], ThiaArtist, sizeof.IDartist, addr bytesWritten, NULL

	mov		eax, [ThisSource.size]
	bswap	eax
	mov		[ThisSource.size], eax
	invoke	WriteFile, [hMF], ThisSource, sizeof.IDsource, addr bytesWritten, NULL

	mov		eax, [ThisComment.size]
	bswap	eax
	mov		[ThisComment.size], eax
	invoke	WriteFile, [hMF], ThisComment, sizeof.IDcomment, addr bytesWritten, NULL

	ret

SetUpMP3File	endp

DisplayError	proc
	invoke	GetLastError
	invoke  FormatMessage,\
		FORMAT_MESSAGE_FROM_SYSTEM+\
		FORMAT_MESSAGE_ALLOCATE_BUFFER,\  
		NULL,\                                                         
		eax,\                                                          
		LANG_NEUTRAL,\                                                 
		LErrStrBuff,\                                                  
		0,\                                                            
		NULL                                                           
	invoke	MessageBox, [gWnd], [LErrStrBuff], NULL, MB_OK
	invoke	LocalFree, [LErrStrBuff]

	ret
DisplayError	endp

section '.idata'	import	data	readable	writeable

	library	kernel32, 	'kernel32', \
			user32, 	'user32', \
			comctl32, 	'comctl32', \
			gdi32, 		'gdi32', \
			dsound,		'dsound', \
			shlwapi,	'shlwapi', \
			lameEnc,	'C:\Program Files\Fasm\EXAMPLES\DirectSound\lame3.97\lame_enc.dll'
;http://www.rarewares.org/mp3.html

	include	'\progra~1\fasm\include\apia\kernel32.inc'
	include	'\progra~1\fasm\include\apia\user32.inc'
	include	'\progra~1\fasm\include\apia\comctl32.inc'
	include	'\progra~1\fasm\include\apia\gdi32.inc'
	include	'lameEnc.inc'

	import	dsound, \
			DirectSoundCaptureCreate8, 'DirectSoundCaptureCreate8', \
			DirectSoundCreate8, 'DirectSoundCreate8', \
			DirectSoundEnumerate, 'DirectSoundEnumerateA', \
			DirectSoundCaptureEnumerate, 'DirectSoundCaptureEnumerateA', \
			SetNotificationPositions, 'SetNotificationPositions'

	import	shlwapi, \
			StrCatBuff, 'StrCatBuffA'

section '.rsrc' 	resource	data		readable

START_BUT		equ 1008
STOP_BUT		equ 1009
CrMP3			equ	1010
CrWav			equ	1011

	directory \
		RT_DIALOG, dialogs, \
		RT_VERSION, versions, \
		RT_MANIFEST, manifests, \
		RT_ICON, icons, \
		RT_GROUP_ICON, group_icons
		
	; resource subdirectories

	resource dialogs, \
		IDD_DLG1, LANG_NEUTRAL, diag

	resource icons, \
		1, LANG_NEUTRAL, icon_data

	resource group_icons, \
		IDI_CLOCK, LANG_NEUTRAL, main_icon

	resource versions, \
		1, LANG_NEUTRAL, version

	resource manifests,\
		1, LANG_ENGLISH+SUBLANG_DEFAULT, manifest

	dialog diag, CAPTION, 6, 6, 239, 146, \
		4 + DS_CENTER + WS_CAPTION + WS_MINIMIZEBOX + WS_SYSMENU + WS_VISIBLE + WS_OVERLAPPED + DS_MODALFRAME + DS_3DLOOK
		dialogitem "msctls_statusbar32", "farrier's DirectSound 2MP3 Recording!", \
					IDC_SBR1, 0, 134, 239, 12, \
					0x50000003
;CONTROL "START",IDC_BTN1,"Button",0x50010F01,18,20,52,22
		dialogitem "Button",				"Start", \
					START_BUT, 94, 42, 54, 28, \
					0x50010F01
;CONTROL "STOP",IDC_BTN2,"Button",0x58010F00,120,22,52,22
		dialogitem "Button",				"Stop", \
					STOP_BUT, 94, 42, 54, 28, \
					0x58010F00
		dialogitem	"Button",				"Create MP3 File", \
					CrMP3, 20, 103, 78, 9, \
					0x50010003
		dialogitem	"Button",				"Create Wav File", \
					CrWav, 130, 103, 68, 9, \
					0x50010003
	enddialog

	icon main_icon, icon_data, "DSR.ICO"

	versioninfo version, VOS__WINDOWS32, VFT_APP, VFT2_UNKNOWN, LANG_ENGLISH+SUBLANG_DEFAULT, 0 , \
		'FileDescription', "farrier's DirectSound 2MP3 Recording!", \
		'LegalCopyright', 'No rights reserved.', \
		'FileVersion', '1.0', \
		'ProductVersion', '1.0', \
		'OriginalFilename', 'DSSound2MP3.exe'

	resdata manifest
		db '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>', 13, 10
		db '<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">', 13, 10
		db '<assemblyIdentity name="DSSound2MP3.exe" processorArchitecture="x86" version="5.1.0.0" type="win32"/> ', 13, 10
		db '<description>"farriers DirectSound 2MP3 Recording!"</description>', 13, 10
		db '<dependency>', 13, 10
		db '<dependentAssembly>', 13, 10
		db '<assemblyIdentity type="win32" name="Microsoft.Windows.Common-Controls" version="6.0.0.0" processorArchitecture="x86" publicKeyToken="6595b64144ccf1df" language="*" />', 13, 10
		db '</dependentAssembly>', 13, 10
		db '</dependency>', 13, 10
		db '</assembly>', 13, 10
	endres
