S_OK			=	0
DS_OK			=	S_OK
DSSCL_NORMAL	=	1
WAVE_FORMAT_PCM	=	1
IDI_CLOCK		=	2
IDD_DLG1		=	1000
START_BUT		=	1008
STOP_BUT		=	1009
CrMP3			=	1010
CrWav			=	1011
IDC_SBR1		=	1013		;identifier for Staus Bar
INFINITE		=	-1
msRecordTime	=	20000
LOCALE_SYSTEM_DEFAULT	=	0


CAPTION equ "farrier's Continuous DirectSound Recording to MP3!"

struct GUID
       Data1 dd 0
       Data2 dw 0
       Data3 dw 0
       Data4 db 8 dup(0)
ends

struct D3DVECTOR
       x dd 0
       y dd 0
       z dd 0
ends

struct	WavRiff
	ChunkID		dd	'RIFF'
	ChunkSize	dd	0
	Format		dd	'WAVE'
	subChunkFmt	dd	'fmt '
	sc1Size		dd	16
	af			dw	1		;AudioFormat
	NumChans	dw	2
	SampRate	dd	44100
	ByteRate	dd	176400
	BlockAlign	dw	4
	BitsPer		dw	16
	sc2			dd	'data'
	sc2Size		dd	0
ends

macro	LockAndGet
{
;Thanks to http://www.koders.com/cpp/fid730B2ECC14C4AC2FD955CDFABA86F76EF1F7D26B.aspx
; for this logic
	cominvk	dscb, GetCurrentPosition, NULL, CurPos
	mov		eax, [CurPos]
	.if	eax, b, [LastDataRead]			;if the current position is less than the previous finishing position
		add	eax, [dscbd.dwBufferBytes]	; it means we have "looped" back to the beginning of the buffer, add size of buffer
										; to prepare for next subtraction
	.endif
	sub		eax, [LastDataRead]			;calculate size of data recorded since last lock and get
	push	eax							;save for later

;Lock capture buffer in order to read the data
	cominvk	dscb, Lock, [LastDataRead], eax, CapDataPtr1, CapDataSize1, CapDataPtr2, CapDataSize2, 0
										;begin lock at previous finish position, LastDataRead
										; end at the calculated value in eax

	invoke	WriteFile, [hWF], [CapDataPtr1], [CapDataSize1], numBW, NULL
	mov		eax, [numBW]
	add		[sizeofdata], eax
;Copy data from capture buffer to MP3 buffer
	invoke	RtlMoveMemory, [SharedMem1], [CapDataPtr1], [CapDataSize1]
	.if	[CapDataPtr2], ne, NULL		;we "wrapped" around, and need to get the chunk starting at the additional chunk at
									; begining of buffer
		invoke	WriteFile, [hWF], [CapDataPtr2], [CapDataSize2], numBW, NULL
		mov		eax, [numBW]
		add		[sizeofdata], eax
	;Copy data from capture buffer to MP3 buffer
		invoke	RtlMoveMemory, [SharedMem2], [CapDataPtr2], [CapDataSize2]
	.endif

;Unlock the capture buffer
	cominvk	dscb, Unlock, [CapDataPtr1], [CapDataSize1], [CapDataPtr2], [CapDataSize2]

;save the current finish position
	pop		eax								;previously saved size of this data chunk
	add		eax, [LastDataRead]				; add this value to the previous ending point
	.if	eax, ae, [dscbd.dwBufferBytes]		; if this sum is greater than the size of the buffer
		sub	eax, [dscbd.dwBufferBytes]		; we've "wrapped" around, subtract size.of.buffer to compensate
	.endif
	mov		[LastDataRead], eax				;save for next time
	.if	[mp3_running]
		invoke	StrCatBuff, szBuffer, 'X', 64	;This would alert the user to a condition where the mp3 routine did not
												; complete before being asked to run agian.  'X' will be displayed in status bar
	.endif
	mov		[mp3_running], 1					;set to show mp3 routine is running, just to check that it always completes 
											;before it is asked to run again.  This is set to zero upon completion
											;of mp3 routine
;	invoke	SetEvent, [hTTCEvent]
}

struct	ID3v2Header
	fileid	db	"ID3"
	version	dw	0003h
	flags	db	0
	size	dd	0			;4 bytes 10987654321098765432109876543210
							;         3         2         1
							;calc = sizeof.year +
							;		sizeof.title +
							;		sizeof.artist +
							;		sizeof.source +
							;		sizeof.comment
ends

struct	IDyear				;Year-Month-Day-DOW
	frameID	db	"TYER"
	size	dd	000000fh
	flags	dw	0
	encode	db	1 dup(0)
	data	db	"2007-04-29-SUN"
ends

struct	IDtitle
	frameID	db	"TIT2"
	size	dd	30
	flags	dw	0
	encode	db	1 dup(0)
	data	db	"Song Title" , 19 dup(0)			;29 dup(0)
ends

struct	IDartist
	frameID	db	"TPE1"
	size	dd	001eh
	flags	dw	0
	encode	db	1 dup(0)
	data	db	"Artist" , 23 dup(0)				;29 dup(0)
ends

struct	IDsource
	frameID	db	"TMED"
	size	dd	0007h
	flags	dw	0
	encode	db	1 dup(0)
	data	db	"RAD/FM"
ends

struct	IDcomment
	frameID	db	"COMM"
	size	dd	001dh
	flags	dw	0
	encode	db	0
	lang	db	"eng"
	short	db	0
	data	db	"Mississippi Public Radio"
ends
